<?php

namespace Teknisa\CMP\Modules\Solicitacao\Modules\Consolidacao\Services;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class sup00100ConsolidacaoDeSolicitacaoService {
    
    protected $connection;
    
    public function __construct($entityManager, $environment){
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment;
    }
    
    public function validaFilial ($filial){
        $param = array();
        $param['P_CDFILIAL'] = $filial;
        $query = "  SELECT
                        CDFILIAL,
                        NMFILIAL,
                        IDCNTRRESC,
                        CDREGIAO,
                        IDFUNCAOFILI
                    FROM
                        FILIAL
                    WHERE
                        (CDFILIAL = :P_CDFILIAL OR :P_CDFILIAL = 'T')
                    ORDER BY 
                        CDFILIAL";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function queryParaCmpSup ($row){
        $param = array();
        $param['P_CDFILSOLI'] = $row['CDFILIALPRINC'];
        $query = "  SELECT
                        IDUTPRODPREF
                    FROM
                        PARCMPSUP
                    WHERE
                        CDFILIAL = :P_CDFILSOLI";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function queryCentComp ($CDFILIAL){
        $param = array();
        $param['P_CDFILIAL'] = $CDFILIAL;
        $query = "  SELECT
                    NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL) AS CDFILCENTCMP,
                        FILCENT.NMFILIAL AS NMFILIAL_CENTRAL
                    FROM 
                        FILIAL FILCENT,
                        FILIAL 
                    WHERE
                        FILIAL.CDFILIAL = :P_CDFILIAL AND
                        NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL) = FILCENT.CDFILIAL";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function insLista ($NRLISTA, $CDLISTA){
        $param = array();
        $param['NRLISTA'] = $NRLISTA;
        $param['CDLISTA'] = $CDLISTA;
        $query = "  INSERT INTO LISTA 
                        (NRLISTA, CDLISTA) 
                    VALUES 
                        (:NRLISTA, :CDLISTA)";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }
}