<?php
namespace Teknisa\CMP\Modules\Solicitacao\Modules\Relatorios\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Cmp08000SolicitacaoDeComprasPorAgrupamento extends \Zeedhi\Framework\Controller\Report
{
    protected $entityManager;
    protected $qr2Strategy;
    protected $newCode;
    protected $environment;
    protected $connection;

    public function __construct($reportService, $entityManager, $qr2Strategy, $newCode, $environment, $connection)
    {
        $this->entityManager       = $entityManager;
        $this->qr2Strategy         = $qr2Strategy;
        $this->reportService       = $reportService;
        $this->newCode             = $newCode;
        $this->environment         = $environment;
        $this->connection          = $connection;
    }

    protected $reportMapping = array (
        
        'CMP08000' =>
            array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                "REGIAO"        => "L_REGIAO",        //nessa parte, são passados os nomes dos campos que o backend pretende receber e os que estamos enviando. É feita uma "conversão/adaptação"
                "GRUPFILI"      => "L_GRUPFILI",
                "DTINI"         => "P_DTINI",
                "DTFIM"         => "P_DTFIM",
                "QUEBRAPAGINA"  => "P_QUEBRAPAGINA",
                "PRODINI"       => "P_PRODINI",
                "PRODFIN"       => "P_PRODFIN",
                "DTINICIAL"     => "P_TDTINI",
                "DTFINAL"       => "P_TDTFIM",
                "PRODUTO"       => "L_PRODUTO"
             )
        ),
        'CMP08001' =>
            array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                "REGIAO"        => "L_REGIAO",        //nessa parte, são passados os nomes dos campos que o backend pretende receber e os que estamos enviando. É feita uma "conversão/adaptação"
                "GRUPFILI"      => "L_GRUPFILI",
                "DTINI"         => "P_DTINI",
                "DTFIM"         => "P_DTFIM",
                "QUEBRAPAGINA"  => "P_QUEBRAPAGINA",
                "PRODINI"       => "P_PRODINI",
                "PRODFIN"       => "P_PRODFIN",
                "DTINICIAL"     => "P_TDTINI",
                "DTFINAL"       => "P_TDTFIM",
                "PRODUTO"       => "L_PRODUTO"
             )
        )
    );
    
    
    public function insertLista($nrlista) 
    {
    	$params = array(
    		"NRLISTA" => $nrlista,
    		"CDLISTA" => $this->environment->getCdOperador()
    	);
    	
    	$sql = "INSERT INTO LISTA (NRLISTA, CDLISTA) VALUES (:NRLISTA, :CDLISTA)";
    	$query = $this->connection->prepare($sql);
    	$query->execute($params);
    }
   
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response)
    {
        $NRLISTA = $this->newCode->getCodeByTableName('NRLISTA', $this->environment->getNrorgTrab(), 1, 10, false);
        
        $row = $request->getRow();

        $this ->insertLista($NRLISTA);
        $row['__report_name'] = $row['REPORT_NAME'];
        $row['DTINICIAL'] = $row['DTINI'];
        $row['DTFINAL'] = $row['DTFIM'];
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
        
    }
}